diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
index 6986c5369..ece775fcc 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
@@ -3,95 +3,82 @@ package net.minecraft.core.player.inventory.container;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.InventorySorter;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ContainerSimple
-    implements Container
-{
-    private String name;
-    private int size;
-    private ItemStack[] items;
-
-    public ContainerSimple(String name, int size)
-    {
+    implements Container {
+    private final @NotNull String name;
+    private final @Nullable ItemStack @NotNull [] items;
+
+    public ContainerSimple(final @NotNull String name, final int size) {
         this.name = name;
-        this.size = size;
-        items = new ItemStack[size];
+        this.items = new ItemStack[size];
     }
 
     @Override
-	public @Nullable ItemStack getItem(int index)
-    {
-        return items[index];
+    public @Nullable ItemStack getItem(final int slot) {
+        return this.items[slot];
     }
 
     @Override
-	public @Nullable ItemStack removeItem(int index, int takeAmount)
-    {
-        if(items[index] != null)
-        {
-            if(items[index].stackSize <= takeAmount)
-            {
-                ItemStack itemstack = items[index];
-                items[index] = null;
-                setChanged();
-                return itemstack;
+    public @Nullable ItemStack removeItem(final int slot, final int takeAmount) {
+        final @Nullable ItemStack stack = this.items[slot];
+
+        if (stack != null) {
+            if (stack.stackSize <= takeAmount) {
+                final @NotNull ItemStack currentStack = stack;
+                this.items[slot] = null;
+                return currentStack;
             }
-            ItemStack itemstack1 = items[index].splitStack(takeAmount);
-            if(items[index].stackSize <= 0)
-            {
-                items[index] = null;
+
+            final @NotNull ItemStack otherHalf = stack.splitStack(takeAmount);
+            if (stack.stackSize <= 0) {
+                this.items[slot] = null;
             }
-            setChanged();
-            return itemstack1;
-        } else
-        {
+
+            return otherHalf;
+        } else {
             return null;
         }
     }
 
     @Override
-	public void setItem(int index, @Nullable ItemStack itemstack)
-    {
-        items[index] = itemstack;
-        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
-        {
-            itemstack.stackSize = getMaxStackSize();
+    public void setItem(final int slot, final @Nullable ItemStack stack) {
+        this.items[slot] = stack;
+
+        if (stack != null && stack.stackSize > this.getMaxStackSize()) {
+            stack.stackSize = this.getMaxStackSize();
         }
-        setChanged();
     }
 
     @Override
-	public int getContainerSize()
-    {
-        return size;
+    public int getContainerSize() {
+        return this.items.length;
     }
 
     @Override
-	public String getNameTranslationKey()
-    {
-        return name;
+    public @NotNull String getNameTranslationKey() {
+        return this.name;
     }
 
     @Override
-	public int getMaxStackSize()
-    {
+    public int getMaxStackSize() {
         return 64;
     }
 
     @Override
-	public void setChanged()
-    {
+    public void setChanged() {
+        // Do nothing
     }
 
     @Override
-	public boolean stillValid(Player entityplayer)
-    {
+    public boolean stillValid(@NotNull final Player player) {
         return true;
     }
 
     @Override
-    public void sortContainer() {
-        InventorySorter.sortInventory(items);
+    public void sort() {
+        InventorySorter.sortInventory(this.items);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index ecf7d7cfb..001586e41 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -128,7 +128,7 @@ public abstract class MenuAbstract
 	 */
 	public ItemStack clicked(InventoryAction action, int[] args, Player player) {
 		if(action.requireCreative()) {
-			if(player.getGamemode().consumeBlocks()) {
+			if(player.getGamemode().hasBlockConsumption()) {
                 LOGGER.warn("Player {} used a creative inventory action but is not in creative mode!", player.username);
 				return null;
 			}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
index ef8021653..bb72be543 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
@@ -19,17 +19,11 @@ public class MenuInventory extends MenuAbstract {
 
 	public ContainerCrafting craftSlots;
 	public Container resultSlots;
-	public boolean active;
 	public ContainerInventory inventory;
 
 	public MenuInventory(ContainerInventory inventory) {
-		this(inventory, true);
-	}
-
-	public MenuInventory(ContainerInventory inventory, boolean active) {
 		craftSlots = new ContainerCrafting(this, 2, 2);
 		resultSlots = new ContainerResult();
-		this.active = active;
 		this.inventory = inventory;
 		addSlot(new SlotResult(inventory.player, craftSlots, resultSlots, 0, 144, 36));
 		
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index fa8af726c..c46bf0af7 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -24,15 +24,10 @@ public class MenuInventoryCreative extends MenuInventory
 	protected int creativeSlotsStart;
 	protected List<ItemStack> searchedItems = new ArrayList<ItemStack>();
 	public String searchText = "";
-	
+
 	public MenuInventoryCreative(ContainerInventory inventoryplayer)
 	{
-		this(inventoryplayer, true);
-	}
-	
-	public MenuInventoryCreative(ContainerInventory inventoryplayer, boolean isNotClientSide)
-	{
-		super(inventoryplayer, isNotClientSide);
+		super(inventoryplayer);
 		
 		creativeSlotsStart = this.slots.size();
 		
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
index 634b1363b..d994e9400 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
@@ -27,7 +27,7 @@ public class Slot
 
 	public void sortSlotInventory() {
 		if (this.container != null) {
-            this.container.sortContainer();
+            this.container.sort();
 		}
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
index 01e0b0fa7..99568caf2 100644
--- a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
+++ b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -72,6 +72,10 @@ public final class NamespaceID implements Comparable<NamespaceID>, CharSequence,
         set(namespace, value);
     }
 
+    public NamespaceID(final @NotNull NamespaceID id) {
+        set(id.namespace(), id.value());
+    }
+
     @Override
     public @NotNull ObjectPool<NamespaceID> getPool() {
         return NamespaceID.POOL;
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
index 098e9bc10..bc8f0e509 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
@@ -177,5 +177,45 @@ public enum Direction {
 		if (mob.xRot > 45) return DOWN;
 		return getHorizontalDirection(mob.yRot);
 	}
-	
+
+	//////////////////
+
+	public static @NotNull Direction[] rotXMap = new Direction[] {
+		Direction.DOWN, Direction.NORTH, Direction.UP, Direction.SOUTH,
+		Direction.UP, Direction.SOUTH, Direction.DOWN, Direction.NORTH,
+		Direction.NORTH, Direction.UP, Direction.SOUTH, Direction.DOWN,
+		Direction.SOUTH, Direction.DOWN, Direction.NORTH, Direction.UP,
+		Direction.WEST, Direction.WEST, Direction.WEST, Direction.WEST,
+		Direction.EAST, Direction.EAST, Direction.EAST, Direction.EAST,
+	};
+
+	public static @NotNull Direction rotateX(@NotNull Direction direction, int amount) {
+		return rotXMap[direction.getId() * 4 + (amount & 0b11)];
+	}
+
+	public static @NotNull Direction[] rotYMap = new Direction[] {
+		Direction.DOWN, Direction.DOWN, Direction.DOWN, Direction.DOWN,
+		Direction.UP, Direction.UP, Direction.UP, Direction.UP,
+		Direction.NORTH, Direction.WEST, Direction.SOUTH, Direction.EAST,
+		Direction.SOUTH, Direction.EAST, Direction.NORTH, Direction.WEST,
+		Direction.WEST, Direction.SOUTH, Direction.EAST, Direction.NORTH,
+		Direction.EAST, Direction.NORTH, Direction.WEST, Direction.SOUTH,
+	};
+
+	public static @NotNull Direction rotateY(@NotNull Direction direction, int amount) {
+		return rotYMap[direction.getId() * 4 + (amount & 0b11)];
+	}
+
+	public static @NotNull Direction[] rotZMap = new Direction[] {
+		Direction.DOWN, Direction.EAST, Direction.UP, Direction.WEST,
+		Direction.UP, Direction.WEST, Direction.DOWN, Direction.EAST,
+		Direction.NORTH, Direction.NORTH, Direction.NORTH, Direction.NORTH,
+		Direction.SOUTH, Direction.SOUTH, Direction.SOUTH, Direction.SOUTH,
+		Direction.WEST, Direction.DOWN, Direction.EAST, Direction.UP,
+		Direction.EAST, Direction.UP, Direction.WEST, Direction.DOWN,
+	};
+
+	public static @NotNull Direction rotateZ(@NotNull Direction direction, int amount) {
+		return rotZMap[direction.getId() * 4 + (amount & 0b11)];
+	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 835fe200c..7bf468882 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -204,7 +204,7 @@ public final class SpawnerMobs {
         if (player.isPlayerSleeping()) {
             return false;
         }
-        if (player.getGamemode().isPlayerInvulnerable()) {
+        if (player.getGamemode().hasInvulnerablePlayer()) {
             return false;
         }
 
@@ -291,7 +291,7 @@ public final class SpawnerMobs {
             if (!player.isPlayerSleeping()) {
                 continue;
             }
-            if (player.getGamemode().isPlayerInvulnerable()) {
+            if (player.getGamemode().hasInvulnerablePlayer()) {
                 continue;
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index f32271393..dc143df72 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -28,7 +28,25 @@ import java.util.*;
 public class Chunk {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final int CHUNK_SIZE_X = 16;
+    /**
+     * Bit mask to convert a world block X coordinate to a X block in chunk coordinate
+     */
+    public static final int CHUNK_MASK_X = 0xF;
+    /**
+     * Amount of bits to shift to convert a world block X coordinate to a chunk X coordinate
+     */
+    public static final int CHUNK_SHIFT_X = 4;
+
     public static final int CHUNK_SIZE_Z = 16;
+    /**
+     * Bit mask to convert a world block Z coordinate to a Z block in chunk coordinate
+     */
+    public static final int CHUNK_MASK_Z = 0xF;
+    /**
+     * Amount of bits to shift to convert a world block Z coordinate to a chunk Z coordinate
+     */
+    public static final int CHUNK_SHIFT_Z = 4;
+
     public static final int CHUNK_SECTIONS = 16;
     public static boolean isLit;
     public boolean isLoaded;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
index 7c009e847..690fa335c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/DensityGeneratorOverworldB173.java
@@ -12,8 +12,8 @@ public class DensityGeneratorOverworldB173
 
     public DensityGeneratorOverworldB173(final @NotNull World world) {
         super(world,
-            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0)),
-            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0, ImprovedPerlinNoise.LegacyNoiseType.BETA)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16, ImprovedPerlinNoise.LegacyNoiseType.BETA)),
             new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32)),
             new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 10, 48)),
             new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 58)),
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
index 64a4d79cd..b9133cd2b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/retro/DensityGeneratorOverworldRetro.java
@@ -11,8 +11,8 @@ public class DensityGeneratorOverworldRetro
     extends DensityGeneratorOverworld {
     public DensityGeneratorOverworldRetro(@NotNull World world) {
         super(world,
-            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0)),
-            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
             new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32)),
             new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 10, 48)),
             new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 58)),
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
index 954c6128b..e4bbccfef 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedPerlinNoise.java
@@ -5,7 +5,6 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.Vector2d;
 import org.joml.Vector2dc;
 
-import java.util.Arrays;
 import java.util.Random;
 
 // Derived from Ken Perlin's Improved Noise reference implementation: https://cs.nyu.edu/~perlin/noise/
@@ -41,16 +40,18 @@ public class ImprovedPerlinNoise
     }
 
     public enum LegacyNoiseType {
-        DEFAULT(true, true),
-        ALPHA(false, false),
-        BETA(true, false);
+        DEFAULT(true, true, false),
+        ALPHA(false, false, true),
+        BETA(true, false, true);
 
         public final boolean handleEdgeCaseY;
         public final boolean handleEdgeCaseZ;
+        public final boolean doFarLands;
 
-        LegacyNoiseType(final boolean handleEdgeCaseY, final boolean handleEdgeCaseZ) {
+        LegacyNoiseType(final boolean handleEdgeCaseY, final boolean handleEdgeCaseZ, final boolean doFarLands) {
             this.handleEdgeCaseY = handleEdgeCaseY;
             this.handleEdgeCaseZ = handleEdgeCaseZ;
+            this.doFarLands = doFarLands;
         }
     }
 
@@ -108,14 +109,14 @@ public class ImprovedPerlinNoise
     @Override
     public double getValue(double x, double y, double z) {
         // Find unit cube that contains point
-        final int X = (int) Math.floor(x) & 255;
-        final int Y = (int) Math.floor(y) & 255;
-        final int Z = (int) Math.floor(z) & 255;
+        final int X = (int) this.fastFloor(x) & 255;
+        final int Y = (int) this.fastFloor(y) & 255;
+        final int Z = (int) this.fastFloor(z) & 255;
 
         // Find relative XYZ of point in cube
-        x -= Math.floor(x);
-        y -= Math.floor(y);
-        z -= Math.floor(z);
+        x -= this.fastFloor(x);
+        y -= this.fastFloor(y);
+        z -= this.fastFloor(z);
 
         // Compute fade curves for each of X, Y, and Z
         final double u = this.fade(x);
@@ -161,7 +162,7 @@ public class ImprovedPerlinNoise
         );
     }
 
-    protected double grad2(final int hash, final double x, final double y) {
+    private double grad2(final int hash, final double x, final double y) {
         final int h = hash & 15;
         final double u = (double) (1 - ((h & 8) >> 3)) * x;
         final double v = h < 4 ? 0.0D : h == 12 || h == 14 ? x : y;
@@ -169,15 +170,15 @@ public class ImprovedPerlinNoise
         return ((h & 1) != 0 ? -u : u) + ((h & 2) != 0 ? -v : v);
     }
 
-    protected double fade(final double t) {
+    private double fade(final double t) {
         return t * t * t * (t * (t * 6 - 15) + 10);
     }
 
-    protected double lerp(final double t, final double a, final double b) {
+    private double lerp(final double t, final double a, final double b) {
         return a + t * (b - a);
     }
 
-    protected double grad(final int hash, final double x, final double y, final double z) {
+    private double grad(final int hash, final double x, final double y, final double z) {
         // Converts low 4 bits of hash code into 12 gradient directions.
         final int h = hash & 15;
         final double u = h < 8 ? x : y;
@@ -186,6 +187,19 @@ public class ImprovedPerlinNoise
         return ((h & 1) == 0 ? u : -u) + ((h & 2) == 0 ? v : -v);
     }
 
+    private double fastFloor(final double value) {
+        if (this.legacyNoiseType.doFarLands) {
+            int intComponent = (int) value;
+            if (value < intComponent) {
+                intComponent--;
+            }
+
+            return intComponent;
+        } else {
+            return Math.floor(value);
+        }
+    }
+
     @Override
     public double @NotNull [] addRegion(
         final double @Nullable [] out,
@@ -215,10 +229,10 @@ public class ImprovedPerlinNoise
                 double xx = (x + xi) * xScale + this.xo;
 
                 // Find X coordinate of unit square that contains point
-                final int X = (int) Math.floor(xx) & 255;
+                final int X = (int) this.fastFloor(xx) & 255;
 
                 // Find relative X of point in square
-                xx -= Math.floor(xx);
+                xx -= this.fastFloor(xx);
 
                 // Compute fade curve for X
                 final double u = this.fade(xx);
@@ -227,10 +241,10 @@ public class ImprovedPerlinNoise
                     double zz = (z + zi) * zScale + this.zo;
 
                     // Find Z coordinate of unit square that contains point
-                    final int Z = (int) Math.floor(zz) & 255;
+                    final int Z = (int) this.fastFloor(zz) & 255;
 
                     // Find relative Z of point in square
-                    zz -= Math.floor(zz);
+                    zz -= this.fastFloor(zz);
 
                     // Compute fade curve for Z
                     final double w = this.fade(zz);
@@ -265,10 +279,10 @@ public class ImprovedPerlinNoise
                 double xx = (x + xi) * xScale + this.xo;
 
                 // Find X coordinate of unit square that contains point
-                final int X = (int) Math.floor(xx) & 255;
+                final int X = (int) this.fastFloor(xx) & 255;
 
                 // Find relative X of point in square
-                xx -= Math.floor(xx);
+                xx -= this.fastFloor(xx);
 
                 // Compute fade curve for X
                 final double u = this.fade(xx);
@@ -277,10 +291,10 @@ public class ImprovedPerlinNoise
                     double yy = (y + yi) * yScale + this.zo;
 
                     // Find Y coordinate of unit square that contains point
-                    final int Y = (int) Math.floor(yy) & 255;
+                    final int Y = (int) this.fastFloor(yy) & 255;
 
                     // Find relative Y of point in cube
-                    yy -= Math.floor(yy);
+                    yy -= this.fastFloor(yy);
 
                     // Compute fade curve for Y
                     final double v = this.fade(yy);
@@ -321,10 +335,10 @@ public class ImprovedPerlinNoise
                 double xx = (x + xi) * xScale + this.xo;
 
                 // Find X coordinate of unit cube that contains point
-                final int X = (int) Math.floor(xx) & 255;
+                final int X = (int) this.fastFloor(xx) & 255;
 
                 // Find relative X of point in cube
-                xx -= Math.floor(xx);
+                xx -= this.fastFloor(xx);
 
                 // Compute fade curve for X
                 final double u = this.fade(xx);
@@ -333,10 +347,10 @@ public class ImprovedPerlinNoise
                     double zz = (z + zi) * zScale + this.zo;
 
                     // Find Z coordinate of unit cube that contains point
-                    final int Z = (int) Math.floor(zz) & 255;
+                    final int Z = (int) this.fastFloor(zz) & 255;
 
                     // Find relative Z of point in cube
-                    zz -= Math.floor(zz);
+                    zz -= this.fastFloor(zz);
 
                     // Compute fade curve for Z
                     final double w = this.fade(zz);
@@ -345,10 +359,10 @@ public class ImprovedPerlinNoise
                         double yy = (y + yi) * yScale + this.yo;
 
                         // Find Y coordinate of unit cube that contains point
-                        final int Y = (int) Math.floor(yy) & 255;
+                        final int Y = (int) this.fastFloor(yy) & 255;
 
                         // Find relative Y of point in cube
-                        yy -= Math.floor(yy);
+                        yy -= this.fastFloor(yy);
 
                         // Compute fade curve for Y
                         final double v = this.fade(yy);
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
index 3d556c9ae..8fbb56fd2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/ChunkPos.java
@@ -30,9 +30,13 @@ public final class ChunkPos implements Externalizable, Cloneable, ChunkPosc {
 
     public ChunkPos(final @NotNull TilePosc tilePos) {
         this(
-            Math.floorDiv(tilePos.x(), Chunk.CHUNK_SIZE_X),
-            Math.floorDiv(tilePos.z(), Chunk.CHUNK_SIZE_Z)
+            tilePos.x() >> Chunk.CHUNK_SHIFT_X,
+            tilePos.z() >> Chunk.CHUNK_SHIFT_Z
         );
+//        this(
+//            Math.floorDiv(tilePos.x(), Chunk.CHUNK_SIZE_X),
+//            Math.floorDiv(tilePos.z(), Chunk.CHUNK_SIZE_Z)
+//        );
     }
 
     public ChunkPos(final @NotNull ChunkPosc chunkPos) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
index 5ae8eb4ec..e90dcfe49 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
@@ -8,7 +8,6 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.ChunkPosition;
 import net.minecraft.core.world.saveddata.SavedData;
 import org.jetbrains.annotations.NotNull;
 
@@ -131,7 +130,7 @@ public class ItemMapSavedData extends SavedData
         for(int i = 0; i < carriedBy.size(); i++)
         {
             HoldingPlayer mapinfo1 = carriedBy.get(i);
-            if(mapinfo1.player.removed || !mapinfo1.player.inventory.func_28018_c(stack))
+            if(mapinfo1.player.removed || !mapinfo1.player.inventory.containsItem(stack))
             {
                 carriedByPlayers.remove(mapinfo1.player);
                 carriedBy.remove(mapinfo1);
diff --git a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
index 2b4340dc8..a6c0f008d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
+++ b/game/core/src/main/java/net/minecraft/core/world/settings/WorldConfiguration.java
@@ -3,12 +3,12 @@ package net.minecraft.core.world.settings;
 import net.minecraft.core.data.gamerule.GameRuleCollection;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.type.WorldTypeGroups;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -17,7 +17,7 @@ public class WorldConfiguration {
     private long numericSeed = new Random().nextLong();
     private @NotNull String stringSeed = "";
     private boolean cheatsEnabled = false;
-    private @NotNull Gamemode gamemode = Gamemode.survival;
+    private @NotNull Gamemode gamemode = Gamemodes.SURVIVAL;
     private @NotNull WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
     private final @NotNull GameRuleCollection gameRuleCollection = new GameRuleCollection();
 
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index a845432f5..30570490f 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -55,6 +55,7 @@ import net.minecraft.core.net.command.commands.CommandTestFor;
 import net.minecraft.core.net.command.commands.CommandTime;
 import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.pos.TilePos;
@@ -69,7 +70,6 @@ import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
-import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.save.ISaveConverter;
@@ -108,6 +108,7 @@ import net.minecraft.server.world.WorldManager;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.server.world.WorldServerMulti;
 import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -119,10 +120,7 @@ import java.io.InputStreamReader;
 import java.net.InetAddress;
 import java.net.UnknownHostException;
 import java.nio.file.Files;
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.List;
-import java.util.Random;
+import java.util.*;
 
 import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
 import static net.minecraft.core.Global.isServer;
@@ -281,21 +279,12 @@ public class MinecraftServer
         EntityItem.enableItemClumping = propertyManager.getBooleanProperty("enable-item-clumping", true);
         UUIDHelper.urlUUID = propertyManager.getStringProperty("uuid-service", "https://api.minecraftservices.com/minecraft/profile/lookup/name/%s");
 
-        String gamemodeProperty = propertyManager.getStringProperty("default-gamemode", "survival");
-        defaultGamemode = null;
-        for (Gamemode gamemode : Gamemode.gamemodesList){
-            if (gamemode.getLanguageKey().replace("gamemode.", "").equals(gamemodeProperty)){
-                defaultGamemode = gamemode;
-                break;
-            }
-        }
-        if (defaultGamemode == null){
-            try{
-                defaultGamemode = Gamemode.gamemodesList[Integer.parseInt(gamemodeProperty)];
-            } catch (Exception e){
-                defaultGamemode = Gamemode.survival;
-            }
+        String gamemodeProperty = propertyManager.getStringProperty("default-gamemode", "minecraft:gamemode/survival");
+        final @Nullable Gamemode gamemodeFromProperty = Registries.GAMEMODES.getItem(gamemodeProperty);
+        if (gamemodeFromProperty == null) {
+            LOGGER.warn("Unrecognised gamemode \"" + gamemodeProperty + "\"! Gamemodes must be in namespace ID format, e.g. \"minecraft:gamemode/survival\".");
         }
+        this.defaultGamemode = Objects.requireNonNullElse(gamemodeFromProperty, Gamemodes.SURVIVAL);
 
         if (defaultWorldType == null)
         {
